<?php
/**
 * @name avaibility
 * @description construction du block avaibility dans les rapports
 *		Tous les blocs avaibility passent par ce code pour construire le graph, donut,...
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */
$is_cli=false;
if(empty($_SERVER['DOCUMENT_ROOT'])) 
{
	$is_cli=true;
	$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
}
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/esia.conf.php';
include_once $path.'/Model_esia.php';
include_once $path.'/Model_adm.php';
include_once $path.'/plugin/report/Model_Report.php';
if(!$is_cli)
{
	include_once '/usr/local/esia/public_html/common.php';
}

$SHORT_OPTS="a:i:s:e:l:";
$LONG_OPTS=array("action:","id:","start:","end:","language:");
if((isset($_POST['block_id']))&&!empty($_POST['block_id'])) // Lors de la modification du bloc
{
	$idInclude= $_POST['block_id'];
	$action= $_GET['action'];	
}
elseif((isset($_GET['id'])) &&!empty($_GET['id'])) // Lors de l'ajout du bloc
{
	$idInclude=$_GET['id'];
	$action=$_GET['action'];
}
else // Lors de l'appel par repor_generate.php
{
	$options = getopt($SHORT_OPTS, $LONG_OPTS);
	
	$action	  = getParam($options,"action","a");
	$idInclude= getParam($options,"id","i");
	$start	  = getParam($options,"start","s");
	$end	  = getParam($options,"end","e");
	$language = getParam($options,"language","l");

	include_once $path.'/plugin/report/lang/'.$language.'.php';
	include_once $path.'/lang/'.$language.'/common_plugin_name.php';
	
	$datetime1 = new DateTime($start);
	$datetime2 = new DateTime($end);
	$diff = $datetime1->diff($datetime2);
	$interval = $diff ->format('%a');

	try
	{
		$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
		$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	}
	catch(Exception $e)
	{
		echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
		echo 'N° : '.$e->getCode();
	}
}
$query=Model_Report::getReportIncludeBlock($dbconnection,$idInclude);
$query= $query[0];
$params = json_decode($query['include_parameter'],true);


//UPDATE interface web
if($action=="generate")
{
    if( $interval == 1 ) {//One day only
        $date = new DateTime();
        $date->setTime(0,0,0);
        $end_date_ts = $date->getTimestamp();
        $end_date_ts--;
    }
    
    $plugins = Model_esia::getPlugin($dbconnection);
    $select_plugins=explode(',', $params['tag']);
    $valid_plugin=array();
    foreach ($plugins as $plugin)
    {
        foreach($select_plugins as $tag )
        {
            if(stristr($plugin['tag'], $tag))
            {
                $valid_plugin[] = $plugin['id'];
            }
        }
    }
    $nodes = array();
    if($params['element_type']=='group_node')
    {
        $nodes = Model_esia::getAllNodeofGroup($dbconnection, null, $params['element_dbid']);
    }
    else 
    {
        foreach ($params['element_dbid'] as $nodeid)
        {
            try
            {
                $infonode=Model_esia::InstanceNode($dbconnection,$nodeid);
                $nodes[]=$infonode;      
            }
            catch(Exception $e)
            {
                
            }
        }	
    }
    $list = array();
    foreach($nodes as $node)
    {
        $services = Model_esia::getServices($dbconnection, $node->getId());
        foreach($services as $service)
        {
            if(in_array($service['plugin_id'],$valid_plugin  ))
            {
                
                $errors = Model_Report::getEsiaErrorServiceId($dbconnection,$service['id'],$start,$end);
                //print_r($errors);
                if(!empty($errors)) 
                { 
                    foreach($errors as $error)
                    {
                       // echo $service['name'].' '.$error['error_type'].' '.$params['calcunknown'].' '.$params['calcwarning'].'<br />' ;
                        if($error['error_type'] == 'unknown' && $params['calcunknown'] == 'on')
                        {
                            $list[]=$error;
                        }
                        elseif($error['error_type'] == 'warning' && $params['calcwarning'] == 'on')
                        {
                            $list[]=$error;
                        }
                        elseif($error['error_type'] == 'critical' && $params['calccritical'] == 'on')
                        {
                            $list[]=$error;
                        }
                    }
                }
            }
        }
    }
    if(empty($params['form']))
    {
        $params['form']='tab2';
    }
    //Affichage
    echo '<div class="clear"></div>';
    //echo'<section class="blockTier">
    echo '<section class="blockView" style="page-break-inside:avoid;">
       		<div class="blockView_title">
	       		<h3 style="text-align:'.$params['title']['style']['text-align'].';
						font-size:'.$params['title']['style']['font-size'].';
						color:'.$params['title']['style']['color'].'"
						><p>'.$params['title']['text'].'</p></h3>
        	</div>
	       	<div class="pad">
        		<p style="text-align:'.$params['description']['style']['text-align'].';
						font-size:'.$params['description']['style']['font-size'].'"
							>'.$params['description']['text'].'</p></div>'; 
    echo '<table class="tab"><thead>';
    if($params['table']['columnshow']['group'] !='none')
    {
        echo '<th>'.$lang['REPORT_DEVICE_GROUP_NAME'].'</th>';
    }
    echo '<th>'.$lang['REPORT_DEVICE_NAME'].'</th>';
    if($params['table']['columnshow']['ip'] !='none')
    {
        echo '<th>'.$lang['REPORT_ADD_IP'].'</th>';
    }
    if($params['table']['columnshow']['description'] !='none')
    {
        echo '<th>'.$lang['REPORT_BLOCK_DESCRIPTION'].'</th>';
    }
    echo '<th>'.$lang['REPORT_SERVICE_NAME'].'</th>';
    if($params['table']['columnshow']['technical_name'] !='none')
    {
    	echo '<th>'.$lang['REPORT_TECHNICAL_NAME'].'</th>';
    }
    echo '<th>'.$lang['REPORT_ERROR_TYPE'].'</th>';
    if($params['table']['columnshow']['message'] !='none')
    {
        echo '<th>'.$lang['REPORT_HAPPEN_MESSAGE'].'</th>';
    }
    echo '<th>'.$lang['REPORT_TIME'].'</th>';
	if($params['table']['columnshow']['time_end'] !='none')
    {
	echo '<th>'.$lang['REPORT_HAPPEN_TIME_ACQUITTE'].'</th>';
    }
    if($params['table']['columnshow']['during'] !='none')
    {
	echo '<th>'.$lang['REPORT_DURING'].'</th>';
    }
    echo '</thead><tbody>';
    foreach ($list as $line)
    {
        echo '<tr>';
        if($params['table']['columnshow']['group'] !='none')
        {
            echo '<td>'.$line['device_group_name'].'</td>';
        }
        echo '<td>'.$line['device_name'].'</td>';
        if($params['table']['columnshow']['ip'] !='none')
        {
            echo '<td>'.long2ip($line['device_ip_addr']).'</td>';
        }
        if($params['table']['columnshow']['description'] !='none')
        {
            echo '<td>'.$line['description'].'</td>';
        }
        $common_name = Model_esia::getCommonName($lang, $line['service_name'], $line['plugin_name']);
        echo '<td>'.$common_name.'</td>';
        if($params['table']['columnshow']['technical_name'] !='none')
        {
            echo '<td>'.$line['service_name'].'</td>';
        }
        echo '<td ';
        switch ($line['error_type'])
        {
            case 'warning':
                echo'class="EventWarning_Incident">'.$lang['REPORT_WARNING'];
                break;
            case 'critical':
                echo'class="EventCritical_Incident">'.$lang['REPORT_CRITICAL'];
                break;
            case 'unknown':
                echo'class="EventUnknown_Incident">'.$lang['REPORT_UNKNOWN'];
                break;
        }
        echo '</td>';
        if($params['table']['columnshow']['message'] !='none')
        {
            echo '<td>'.$line['happen_message'].'</td>';
        }
        echo '<td>'.$line['time'].'</td>';
		if($params['table']['columnshow']['time_end'] !='none')
	    {
			echo'<td>'.$line['time_end'].'</td>';
		}
		if($params['table']['columnshow']['during'] !='none')
		{
			echo'<td>'.$line['during'].'</td>';
		}
		echo '</tr>';
	}
    echo'</tbody></table>';
}
elseif($action=="node")
{
    $nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
    $list=array();
    
    foreach($nodes as $node)
    {
        $arr = array('id'=>$node->getId(),'parent_name'=>$node->getGroup().'>'.$node->getName());
        if($params['element_type']=='node')
        {
            if(in_array($node->getId(),$params['element_dbid']))
            {
                $arr['selected']=1;
            }
        }
        $list[]= $arr;
    }
    echo json_encode($list);
}
elseif($action=="group_node")
{
    $arr = Model_esia::getGroupDeviceIn($dbconnection);
    $list =array();
    foreach($arr as $top)
    {
        $tmp = convert_tree_to_select($top,0);
        $list = array_merge($list, $tmp);
    }
    if($params['element_type']=='group_node')
    {
        foreach($list as &$elem)
        {
            if(in_array($elem['id'], $params['element_dbid']))
            {
                $elem['selected']=1;
            }
        }
    }
    echo json_encode($list);
    
}
elseif($action=="update")
{
    $template_path = $path.'/plugin/report/templates/';
    $smarty->assign('blockid',$query['include_id']);
    $smarty->assign('canevas_id',$query['include_canevas_id']);
    if(isset($_POST['block_id'])&&!empty($_POST['block_id']))
    {
        //Title
        $params['title']['text']=$_POST["block_name"];
        $size = $_POST["name_size"];
        $params['title']['style']['font-size']=$size."px";
        $params['title']['style']['text-align']=$_POST["name_position"];
        $params['title']['style']['color']=$_POST["block_color"];
        
        //Descr
        $params['description']['text']=$_POST["block_description"];
        $size=$_POST["block_size"];
        $params['description']['style']['font-size']=$size."px";
        $params['description']['style']['text-align']=$_POST["description_position"];

        //
        // Forme
        $params['form']=$_POST['form'];
        // Seuil de Warning et Critical
        $params['criticalThreshold']=$_POST['criticalThreshold'];
        $params['warningThreshold']=$_POST['warningThreshold'];
        
        // Calcul de la dispo
        if( empty($_POST['calcunknown']) )	$_POST['calcunknown'] = 'none';
        if( empty($_POST['calcwarning']) )	$_POST['calcwarning'] = 'none';
        if( empty($_POST['calccritical']) )	$_POST['calccritical'] = 'none';
        $params['calcunknown']=$_POST['calcunknown'];
        $params['calcwarning']=$_POST['calcwarning'];
        $params['calccritical']=$_POST['calccritical'];
        //
        if( empty($_POST['plugin_tag']) )
        {
            $params['tag']='RAID,HEALTH';
        }
        else 
        {
            $params['tag']= $_POST['plugin_tag'];
        }
        //Paramètre du tableau
        if( empty($_POST['tab_col_group']) )	$_POST['tab_col_group'] = 'none';
        if( empty($_POST['tab_col_ip']) )	$_POST['tab_col_ip'] = 'none';
        if( empty($_POST['tab_col_descr']) )	$_POST['tab_col_descr'] = 'none';
        if( empty($_POST['tab_col_technical_name']) )    $_POST['tab_col_technical_name'] = 'none';
        if( empty($_POST['tab_error_msg']) )	$_POST['tab_error_msg'] = 'none';
		if( empty($_POST['tab_col_time_end']) )   $_POST['tab_col_time_end'] = 'none';
        if( empty($_POST['tab_col_during']) )   $_POST['tab_col_during'] = 'none';

        $params['table']['columnshow']['group']=$_POST['tab_col_group'];
        $params['table']['columnshow']['ip']=$_POST['tab_col_ip'];
        $params['table']['columnshow']['description']=$_POST['tab_col_descr'];
		$params['table']['columnshow']['technical_name']=$_POST['tab_col_technical_name'];
        $params['table']['columnshow']['message']=$_POST['tab_error_msg'];
		$params['table']['columnshow']['time_end']=$_POST['tab_col_time_end'];
        $params['table']['columnshow']['during']=$_POST['tab_col_during'];

        //Type d'affichage
        $params['element_type']=$_POST['select_type_link'];
        $params['element_dbid']=$_POST['elementselect'];
       
        $paramSave = json_encode($params);
        
        Model_Report::UpdtReportIncludeBlock($dbconnection,$_POST['block_id'],$query['include_block_id'],$query['include_canevas_id'],$query['include_position'],$paramSave);
        if($params['calcunknown']='none' && $params['calcwarning']== 'none' && $params['calccritical']=='none')
        {
            $smarty->assign('l_warning',$lang['REPORT_AVA_UNCHECKED_ALLBOXES']);
            $smarty->assign('l_success',$lang['UPDATE_REPORT_SUCCESS']);
        }
        else
        {
            $smarty->assign('l_success',$lang['UPDATE_REPORT_SUCCESS']);
        }
    }
    //explode pour le formulaire afin de spécifier la taille dans un input type numéric
    $taille = explode("px", $params['title']['style']['font-size']);
    $smarty->assign('title_police_size',$taille[0]);
    $taille = explode("px", $params['description']['style']['font-size']);
    $smarty->assign('description_police_size',$taille[0]);
    $smarty->assign('description_align',$params['description']['style']['text-align']);
    $smarty->assign('title_align',$params['title']['style']['text-align']);
    $smarty->assign('params',$params);
    $smarty->assign('action','update');
    //on liste les différents groupes de noeud
    $arr = Model_esia::getGroupDeviceIn($dbconnection);
    $select =array();
    foreach($arr as $top)
    {
        $tmp = convert_tree_to_select($top,0);
        $select = array_merge($select, $tmp);
    }
    $smarty->assign('adm_nodegroup', $select);
    
    $smarty->display($template_path.'hardware_incident.html');
}
/*@NAME: convert_tree_to_select
 *@IN: $top un tableau associatif de type renvoyer par Model_esia::getGroupDeviceIn($dbconnection)
 *	$parent_id id du groupe du groupe parent
 *@OUT: un tableau contenant les noms des groupes de device enfants
 *array('id'=>$row->device_group_id,
 *		'name'=> $row->device_group_name,
 'level'=> niveau dans le tableau
 'id du parent'=> niveau dans le tableau
 *@TREAT: FONCTION RECURSIVE !!!!! (utilisée avec la fonction getGroupDeviceIn)
 *		transforme un tableau de tableau récursif de  getGroupDeviceIn en tableau simple avec une valeur 'level' indiquant le niveau du auquelle ils se trouvent
 *@EXCEPTION: /
 */

function convert_tree_to_select($top,$itt,$parentid=null,$parentname=null)
{
    /*for($i=0;$i<$itt;$i++)
     echo'=';
     echo $top['name'].'<br />';*/
    $pname=null;
    if(isset($parentname))
    {
        $pname = $parentname.' > '.$top['name'];
    }
    else
    {
        $pname = $top['name'];
    }
    $arr=array();
    $arr[]=array('id'=>$top['id'],'name'=>$top['name'],'level'=>$itt,'parent'=>$parentid,'parent_name'=>$pname);
    $itt++;
    if(isset($top['child']))
    {
        $tmp=array();
        foreach($top['child'] as $child)
        {
            $tmp = convert_tree_to_select($child,$itt,$top['id'],$pname);
            $arr = array_merge($arr, $tmp);
        }
    }
    
    return $arr;
}
/**
 @brief retourne la valeur associé à la clé
 @detail retourne la valeur associé au paramètre. ou une valeur par défaut
 @params array $options le tableau de paramètre global
 @params string $name1 le nom court du paramètre (ex: -H 127.0.0.1)
 @params string $name2 le nom long du paramètre (ex: --host 127.0.0.1)
 @params string $default (optionnel) la valeur par défaut du paramètre s'il n'est pas spécifié
 @retval	null|mixed la valeur du paramètre
 @throw void
 */
function getParam($options,$name1,$name2,$default=null)
{
    if( isset( $options[$name1] ) ) return $options[$name1];
    if( isset( $options[$name2] ) ) return $options[$name2];
    return $default;
}
function eliminateAvaibilityError($percent, $inconnu='on',$warning='on',$critical='on')
{
    if(!isset($percent['ok']['nbrsec']))	$percent['ok']['nbrsec']=0;
    if(!isset($percent['ok']['percent']))	$percent['ok']['percent']=0;
    
    if($inconnu !='on' && isset($percent['unknown']))
    {
        $percent['ok']['nbrsec']= $percent['ok']['nbrsec'] + $percent['unknown']['nbrsec'];
        $percent['ok']['percent']= $percent['ok']['percent'] + $percent['unknown']['percent'];
        $percent['unknown']=array('nbrsec'=>0,'percent'=>0);
    }
    if($warning !='on' && isset($percent['warning']))
    {
        $percent['ok']['nbrsec']= $percent['ok']['nbrsec'] + $percent['warning']['nbrsec'];
        $percent['ok']['percent']= $percent['ok']['percent'] + $percent['warning']['percent'];
        $percent['warning']=array('nbrsec'=>0,'percent'=>0);
    }
    if($critical !='on' && isset($percent['critical']))
    {
        $percent['ok']['nbrsec']= $percent['ok']['nbrsec'] + $percent['critical']['nbrsec'];
        $percent['ok']['percent']= $percent['ok']['percent'] + $percent['critical']['percent'];
        $percent['critical']=array('nbrsec'=>0,'percent'=>0);
    }
    if($percent['ok']['percent'] > 100)
    {
        $percent['ok']['percent']=100;
    }
    return $percent;
}
?>
