<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un block et vérifie les droits d'accès
 *APRES l'inclusion du common_block les variables suivantes sont créées:
 *PHP:
 *      $dbconnection objet PDO de connexion à la DB
 *      $webplugin_path chemin d'accès au web plugin de repport (default: /usr/local/esia/public_html/plugin/report/
 *      $lang tableau associatif avec les variables de langue
 *      $action l'action passé dans l'url ou 'view'
 *      $gendate tableau associatif reprenant les paramètres global avec les clés suivantes:
 *               ['start']  timestamps de début
 *               ['end']    timestamps de fin
 *               ['interval'] interval en nombre de jour au format php. voir %a par rapport à la date de début  https://www.php.net/manual/fr/dateinterval.format.php
 *      $block les données du block en DB
 *      $parameters un tableau associatif reprenant les paramètres du block
 * SMARTY
 *      $block les informations du block
 *      $parameters les parametres du block (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
require_once REPORT_COMMON_BLOCK;

if($action=="generate")
{
    $list_incident = array();
    $userid=null;
    if(is_null($user)==false)
    {
        $userid = $user->getId();
    }
    else
    {
        $report_user = Model_Report::getOwnerCanevas($dbconnection,$block['include_canevas_id']);
        $userid = $report_user[0];
    }
    $data=array();
    //gestion du niveau d'erreur
    $error_type ='';
    $parameters = $block['parameters'];
    if(!array_key_exists('highligth_warning', $parameters))
    {
    	$parameters['highligth_warning']=30;
    }
    if(!array_key_exists('highligth_critical', $parameters))
    {
    	$parameters['highligth_critical']=60;
    }
    if(!array_key_exists('filter_during', $parameters))
    {
    	$parameters['filter_during']=0;
    }
    if($parameters['affiche_critical']=='on')
    {
        $error_type .='critical,';
    }
    if($parameters['affiche_warning']=='on')
    {
        $error_type .='warning,';
    }
    if($parameters['affiche_unknown']=='on')
    {
        $error_type .='unknown,';
    }
    $error_type = rtrim($error_type,',');
	if($parameters['type']=="service")
	{
        $data = Model_Report::getRepportIncidentBlock($dbconnection,$start,$end,$parameters['serviceid'],Model_Report::BYSERVICE,$error_type);
	}
	elseif($parameters['type']=="noeud" || $parameters['type']=="groupenoeud")
	{
        $tab_id_node = array();
        //on créer un tableau de noeud
        if($parameters['type']=="groupenoeud")
        {
            $tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$parameters['groupnodeid']);
            foreach ($tab_group_node as $node)
            {
                $tab_id_node[] = $node->getId();
            }
        }
        else
        {
            $tab_id_node=$parameters['nodeid'];
        }
		$no_incidents_html = '';
        $data = Model_Report::getRepportIncidentBlock($dbconnection,$start,$end,$tab_id_node,Model_Report::BYNODE,$error_type);
	}
    $arr=array();
    foreach ($data as $line)
    {
    	$during_minut = intdiv($line['during_second'],60);
    	if($during_minut > $parameters['filter_during'])
    	{
	        $common_name = Model_esia::getCommonName($lang, $line['service_name'], $line['plugin_name']);
	        $out = preg_replace('#\|[a-z].*\n#',"",$line['happen_message']);
	        $datestart = date_format(new DateTime($line['time']),'d/m/Y H:i:s');
	        $dateend = date_format(new DateTime($line['time_end']),'d/m/Y H:i:s');
	        $during = preg_replace('#^000#','',$line['during']);
	        if(preg_match('#^([0-9]{3})\s+([0-9\:]*)#',$during,$regs))
	        {
	            $day = ltrim($regs[1],'0');
	            if($day > 1)
	            {
	                $day = $day.' '.$lang['REPORT_DAYS'];
	            }
	            else
	            {
	                $day = $day.' '.$lang['REPORT_DAY'];
	            }
	            $during = $day.' '.$regs[2];
	        }
	        $highlight='none';
	        if($during_minut > $parameters['highligth_critical'])
	        {
	        	$highlight='critical';
	        }
	        elseif($during_minut > $parameters['highligth_warning'])
	        {
	        	$highlight='warning';
	        }
	        $arr[]= array('group_name'=>$line['group_name'],
	                      'node_name'=>$line['device_name'],
	                      'description'=>htmlEntities(nl2br($line['description']), ENT_QUOTES),
	                      'ip'=>$line['ip'],
	                      'service_name'=>$common_name,
	                      'technical_name'=>$line['service_name'],
	                      'error_type'=>$line['error_type'],
	                      'message'=>$out,
	                      'start'=>$datestart,
	                      'end'=>$dateend,
	                      'during'=>$during,
	        			  'highlight'=>$highlight
	        );
    	}
    }
    $smarty->assign('incidents',$arr);
}
elseif($action=="update")
{
	//print_r($block);
	$parameters = $block['parameters'];
	if(!array_key_exists('highligth_warning', $parameters))
	{
		$parameters['highligth_warning']=30;
	}
	if(!array_key_exists('highligth_critical', $parameters))
	{
		$parameters['highligth_critical']=60;
	}
	if(!array_key_exists('filter_during', $parameters))
	{
		$parameters['filter_during']=0;
	}
	$smarty->assign('param',$parameters);	
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
			$block = getPostDefaultParams($block,$_POST);
			$parameters = $block['parameters'];
			// Service & Noeud
			if($parameters['type']=='service')
			{
				$parameters['nodeid']=$_POST['nodes'];
				$parameters['serviceid']=$_POST['services'];
			}
			elseif ($parameters['type']=='noeud')
			{
				$parameters['nodeid']=$_POST['nodes'];
			}
			else
			{
				$parameters['groupnodeid']=$_POST['groupnodes'];
			}

			// Affichage colonne
            $parameters['affiche_technical_name']=$_POST['technical_name'];
			$parameters['affiche_message']=$_POST['messageError'];
			$parameters['affiche_ip']=$_POST['add_ip'];
			$parameters['affiche_time_end']=$_POST['time_end'];
			$parameters['affiche_duree']=$_POST['duree'];
			$parameters['affiche_groupNoeud']=$_POST['groupNoeud'];

			// Affichage Erreur
			$parameters['affiche_warning']=$_POST['levelWarning'];
			$parameters['affiche_critical']=$_POST['levelCritical'];
			$parameters['affiche_unknown']=$_POST['levelUnknown'];
			//Mise en évidence des donnés
			$parameters['highligth_warning']=$_POST['highligth_warning'];
			$parameters['highligth_critical']=$_POST['highligth_critical'];
			$parameters['filter_during']=$_POST['filter_during'];
			$paramSave = json_encode($parameters);
			Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}

		$smarty->assign('block',$block);
		$smarty->assign('param',$parameters);
	}
	//recupération des styles
	$title = $parameters['title']['style'];
	$description = $parameters['description']['style'];
	if(array_key_exists('color',$title))
	{
		$title = 'text-align:'.$parameters['title']['style']['text-align'].'; font-size:'.$parameters['title']['style']['font-size'];
		$title.= 'color:'.$parameters['title']['style']['color'].';';
		$description = 'text-align:'.$parameters['description']['style']['text-align'].'; font-size:'.$parameters['description']['style']['font-size'];
		$description.= 'color:'.$parameters['description']['style']['color'].';';
	}
	$title = getBlockStyle($title,14,'left','#575759');
	$description = getBlockStyle($description,12,'left','#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$listnode = array();
	$list_group_node =array();
	//Récupération des services
	if($parameters['type']=="service")
	{
		if(!empty($parameters['serviceid']))
		{
			$services = Model_esia::getServices($dbconnection,null,$parameters['serviceid']);
			foreach($services as $ser)
			{
				if(!in_array($ser['device_id'],$listnode))
					$listnode[]=$ser['device_id'];
			}
			foreach($services as $ser)
			{
				$listservice[]=$ser['id'];
			}
		}
		$smarty->assign('serviceid',$listservice);

		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();

		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$listnode))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected
			);
		}
	}
	elseif($parameters['type']=="noeud")
	{
		//Récupération des noeuds
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();
		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$parameters['nodeid']))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected

			);
		}
	}
	$smarty->assign('adm_list_node', $list);
	$smarty->assign('adm_list_group_node', $list_group_node);
	$smarty->assign('action','update');
}
elseif($action=="group_node")
{
	$parameters = $block['parameters'];
	$arr = Model_esia::getGroupDeviceIn($dbconnection);
	$list =array();
	foreach($arr as $top)
	{
		$tmp = convert_tree_to_select($top,0);
		$list = array_merge($list, $tmp);
	}
		foreach($list as &$elem)
		{
			if(in_array($elem['id'], $parameters['groupnodeid']))
			{
				$elem['selected']=1;
			}
		}
	echo json_encode($list);
	
}
elseif($action =="getservice")
{
	if(isset($_GET['nodeid']))
	{
		$tablenodeid = json_decode($_GET['nodeid']);
		$list=array();
		foreach($tablenodeid as $nodeid)
		{
			$node = Model_esia::InstanceNode($dbconnection, $nodeid);
			if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
			{
				$services = Model_esia::getServices($dbconnection,$node->getId());
				foreach ($services as $service)
				{
					$common_name = Model_esia::getCommonName($lang, $service['name'],$service['check_plugin_name']);
					$list[$service['id']]=$node->getName().' > '.$common_name;
				}
			}
		}
		echo json_encode($list);
		exit(0);
	}
}
$smarty->display($webplugin_path.'/blocks/templates/incident.html');
?>
