<?php
/**
 * @name report_canevas
 * @description controle canevas
 *		Toutes les actions reliées au canevas sont traitées dans report_canevas
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
include_once $path.'/Model_esia.php';
include_once $path.'/Model_adm.php';
include_once 'Model_Report.php';

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_REPORT');
$plugin_url = $arr[0]['apache_path'];

$page_url = "$plugin_url/".$arr[0]['index_page'];
$template_path = $path.$plugin_url.'templates/';
$path_data = $path.'/data/report/pictures/';
$path_folder = $path.'/data/report/canevas/';
$navbar->addElement($lang['REPORT'], '/report_control.php');
$deleteimage=false;

if($user->getDroits($dbconnection,"report_canevas"))
{
	$smarty->assign('report_canevas', 1);
}

// Droit sur le canevas

if(isset($_GET['action']))
{
	$action = $_GET['action'];
}
else
{
	$action='view';
}
$smarty->assign('action',$action);
$smarty->assign('template_path',$template_path);

$param['lang']=$_POST['language'];
if($param['lang']!=null)
{
		$smarty->assign('language',$param['lang']);
}
else
{
		$smarty->assign('language',$user->getLang());
}

// Ajouter un bloc à un rapport
if($action =="addBlock")
{
	$idCanevas=$_GET['id'];
	$idBlock=$_POST['NewBlock'];
	$query=Model_Report::getReportBlock($dbconnection,$idBlock);
	$query=$query[0];
	$parameter=$query['block_default_parameter'];
	$blockRelier=Model_Report::getAllBlockOfCanevas($dbconnection,$idCanevas);

	$position=count($blockRelier); // Compte le nombre de block present pour avoir la position du nouveau
	try
	{
		$query=Model_Report::addReportIncludeBlock($dbconnection,$idBlock,$idCanevas,$position,$parameter);
		$smarty->assign('l_success',$lang['REPORT_ADD_BLOCK_SUCCES']);
	}
	catch (EsiaDbException $e)
	{
		$smarty->assign('l_error',$e->getMessage());
	}

  $action='update';
  $smarty->assign('action',$action);
}
// Supprimer un bloc dans la liste des blocs d'un canevas
elseif($action =="deleteBlock")
{
	$idCanevas=$_GET['id'];
	$idBlock=$_GET['idBlock'];
	$query=Model_Report::getReportIncludeBlock($dbconnection,$idBlock);
	$query=$query[0];
	$smarty->assign('del_block',$query);
	if(!empty($idCanevas))
	{
		try
		{
			$query=Model_Report::delReportIncludeBlock($dbconnection,$idBlock,$idCanevas);
			$smarty->assign('l_success',$lang['REPORT_DELETE_BLOCK_SUCCES']);
			$smarty->assign('action','update');
			$action='update';
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
}
// Sauver l'ordre des blocs dans la liste des blocs d'un canevas
elseif ($action =="SauverOrdre")
{
	$idCanevas=$_GET['id'];
	$ListBlock=json_decode($_POST['blockjson'],True);

	try
	{
		foreach ($ListBlock as $val)
		{
			$query=Model_Report::getReportIncludeBlock($dbconnection,$val['id']);
			$query=$query[0];
			$query=Model_Report::UpdtReportIncludeBlock($dbconnection,$val['id'],$query['include_block_id'],$idCanevas,$val['position'],json_encode($query['parameters']));
		}
		$smarty->assign('l_success',$lang['REPORT_ORDRE_BLOCK_SUCCES']);
	}
	catch(Exception $e)
	{
		$smarty->assign('l_error',$e->getMessage());
	}

  $action='update';
	$smarty->assign('action',$action);
}

if($action =="update" )
{
	if(isset($_GET['sendsucces']))
	{
		$smarty->assign('l_success',$lang['REPORT_GENERATE_SUCCES']);
	}
  $rightOnCanevas = Model_Report::getReportSendUsers($dbconnection,$_GET["id"],$user->getId());
	$rightOnCanevas=$rightOnCanevas[0];
	if($rightOnCanevas['canevas_user_writing']==true)
	{
		$smarty->assign('report_writing_right',1);
	}

  $blockRelier=Model_Report::getAllBlockOfCanevas($dbconnection,$_GET["id"]);
  $block=Model_Report::getReportBlock($dbconnection);
  $blockname=extract_name_block($blockRelier);

  //On groupe les blocks par groupe, on traduit et on trie
  $tmp = array();
  $another = array();
  foreach($block as $row)
  {
	  if( empty($row['block_group']))
	  {
		  $another[$lang[$row['block_name']]]=$row;
	  }
	  else
	  {
		  if( isset($lang['REPORT_BLOCK_GROUP_'.$row['block_group']]) )
		  {
		  	$key = $lang['REPORT_BLOCK_GROUP_'.$row['block_group']];
		  }
		  else
		  {
			  $key = $row['block_group'];
		  }

		  if(!isset($tmp[$key]))
		  {

			  $tmp[$key] = array();
		  }
		  $tmp[$key][$lang[$row['block_name']]] = $row;
	  }
  }
  ksort($tmp);

  $tmp[$lang['REPORT_BLOCK_GROUP_ANOTHER']] = $another;
  $block = $tmp;

  foreach($block as $group_name=>$row)
  {
	  ksort($row);
	  $block[$group_name] = $row;
  }

  $smarty->assign('ListBlock',$blockRelier);
  $smarty->assign('ListBlockName',$blockname);
  $smarty->assign('ListBlockToAdd',$block);

	$query=Model_Report::getReportCanevas($dbconnection,$_GET["id"]);
	$query= $query[0];

	$date_start = new DateTime();
	$date_end = new DateTime();

	switch ($query['canevas_interval'])
	{
		case "1 year":
			$date_start->sub(new DateInterval("P1Y"));
			break;
		case "1 mon":
			$date_start->sub(new DateInterval("P1M"));
			break;

		case "7 days":
			$date_start->sub(new DateInterval("P1W"));
			break;

		case "1 day":
			$date_start->sub(new DateInterval("P1D"));
			break;
	}
	$param = json_decode($query['canevas_parameter'],true);
	$smarty->assign('NameRapport',str_replace('_',' ',$param['title']['text']));
	$smarty->assign('date_start',date_format($date_start,'d/m/Y'));
	$smarty->assign('date_end',date_format($date_end,'d/m/Y'));
}

$smarty->assign('id',$_GET["id"]);
$smarty->display($template_path.'dialog_block.html');

/**
 * @brief retourne les noms (array) personnalisés des blocs
 * @detail retourne les noms personnalisés des blocs
 * @params array $block contient le json parameter des blocs
 * @retval array contenant les noms
 */
function extract_name_block($block)
{
	$blockname = array();
	$name = array();
	$cmpt=0;
	foreach ($block as $val)
	{
		array_push($blockname,json_decode($val['include_parameter'],true));
		array_push($name,$blockname[$cmpt]['title']['text']);
		$cmpt++;
	}
	return $name;
}
