<?php
/**
 * @name report_canevas
 * @description controle canevas
 *		Toutes les actions reliées au canevas sont traitées dans report_canevas
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
include_once $path.'/Model_esia.php';
include_once $path.'/Model_adm.php';
include_once 'Model_Report.php';

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_REPORT');
$plugin_url = $arr[0]['apache_path'];

$page_url = "$plugin_url/".$arr[0]['index_page'];
$template_path = $path.$plugin_url.'templates/';
$path_data = $path.'/data/report/pictures/';
$path_folder = $path.'/data/report/canevas/';
$navbar->addElement($lang['REPORT'], '/report_control.php');
$deleteimage=false;

if($user->getDroits($dbconnection,"report_canevas"))
{
	$smarty->assign('report_canevas', 1);
}

// Droit sur le canevas

if(isset($_GET['action']))
{
	$action = $_GET['action'];
}
else
{
	$action='view';
}
$smarty->assign('action',$action);
$smarty->assign('template_path',$template_path);


// Supprimer une image dans la liste des images pour le rapport
if ($action =="deleteImage")
{
	$img=$_GET['img'];
	$idCanevas=$_GET['id'];
	$smarty->assign('Image',$img);
	$smarty->assign('id',$idCanevas);

	if(!empty($_POST['idCan']) && isset($_POST['idCan']))
	{
		try
		{
			if($img!="min_report-logo.png")
			{
				$returDelImg=unlink($path_data."miniature/".$img);
				if($returDelImg==true)
				{
					$nameImg = explode("min_", $img);
					$returDelImg=unlink($path_data.$nameImg[1]);
					if($returDelImg==true)
					{
						$deleteimage=true;
						$smarty->assign('l_success',$lang['REPORT_DELETE_IMAGE_TEXT']);
						$smarty->assign('action','update');
						$action='update';
					}
					else
					{
						throw new Exception('File img not writable');
					}
				}
				else
				{
					throw new Exception('File img miniature not writable');
				}
			}
			else
			{
				throw new Exception('File img esia not writable');
			}
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
}

// Modifier ou Ajouter un canevas
if($action =="update" || $action=="add")
{
	$rightOnCanevas = Model_Report::getReportSendUsers($dbconnection,$_GET["id"],$user->getId());
	$rightOnCanevas=$rightOnCanevas[0];
	if($rightOnCanevas['canevas_user_writing']==true)
	{
		$smarty->assign('report_writing_right',1);
	}

	if(isset($_POST["Canevas_Name"])&&!empty($_POST["Canevas_Name"]))
	{
		switch ($_POST["Interval"])
		{
			case $lang['REPORT_CANEVAS_INTERVAL_YEAR']:
				$inter="1 year";
				break;

			case $lang['REPORT_CANEVAS_INTERVAL_MONTH']:
				$inter="1 mon";
				break;

			case $lang['REPORT_CANEVAS_INTERVAL_WEEK']:
				$inter="7 days";
				break;

			case $lang['REPORT_CANEVAS_INTERVAL_DAY']:
				$inter="1 day";
				break;
		}

		// Param CanevasRapport
		$param['title']['text']=remove_accents(str_replace(' ','_',$_POST["NameRapport"]));
		$param['title']['style']['font-size']=$_POST["namesize"]."px";
		$param['title']['style']['color']=$_POST["blockcolor"];
		$param['NameClient']=$_POST["NameClient"];
		$param['DescriptionHeader']=$_POST['DescriptionHeader'];
		$param['NomPersonneGenerateReport']=$_POST['NomPersonneGenerateReport'];
		$param['ListUser']=$_POST['users'];
		$param['SubjetMail']=$_POST['SubjetMail'];
		$param['TextMail']=strip_tags($_POST['TextMail']);
		$param['lang']=$_POST['language'];

		try
		{
			if($_FILES['imageHeader']['name']!=null) // Si une nouvelle image
			{
				//test si il n'y a pas d'erreur
				if ($_FILES['imageHeader']['error'])
				{
					switch ($_FILES['imageHeader']['error'])
					{
						case 1: // UPLOAD_ERR_INI_SIZE
							throw new Exception('file exceeds the maximum size by server (php.ini)'); break;
						case 2: // UPLOAD_ERR_FORM_SIZE
							throw new Exception('file exceeds the maximum size by HTML form'); break;
						case 3: // UPLOAD_ERR_PARTIAL
							throw new Exception('File transfer was interrupted'); break;
						case 4: // UPLOAD_ERR_NO_FILE
							throw new Exception('the size of file was null'); break;
						default:  throw new Exception('Unknown error');
					}
				}

				if(!file_exists($path_data.$_FILES['imageHeader']['name'])) // Si elle n'existe pas déjà
				{
					if(move_uploaded_file($_FILES['imageHeader']['tmp_name'],$path_data.$_FILES['imageHeader']['name'])==true) // Si le dwl s'est bien passé
					{
						$param['imageHeader']="min_".$_FILES['imageHeader']['name'];

						//thumbnail creation
						preg_match("/.(\w*)$/", $_FILES['imageHeader']['name'], $match);
						if(is_array($match))
						{
							$file_ext=$match[1];
						}

						$thumbnail = $path_data."miniature/min_".$_FILES['imageHeader']['name'];
						$upload_image = $path_data.$_FILES['imageHeader']['name'];

						list($width,$height) = getimagesize($upload_image);
						$ratio = $width/$height;
						$NouvelleHauteur = 58;
						$NouvelleLargeur = (($width * (($NouvelleHauteur * 100)/$height))/100 );

						$thumb_create = imagecreatetruecolor($NouvelleLargeur,$NouvelleHauteur);

						$white = imagecolorallocate($thumb_create, 255, 255, 255);
						imagefill($thumb_create, 0, 0, $white);

						switch($file_ext)
						{
							case 'jpg':
								$source = imagecreatefromjpeg($upload_image);
								break;
							case 'jpeg':
								$source = imagecreatefromjpeg($upload_image);
								break;
							case 'png':
								$source = imagecreatefrompng($upload_image);
								break;
							case 'gif':
								$source = imagecreatefromgif($upload_image);
								break;
							case 'bmp':
								$source = imagecreatefrombmp($upload_image);
								break;
							default:
								$source = imagecreatefromjpeg($upload_image);
						}

						imagecopyresampled($thumb_create , $source, 0, 0, 0, 0, $NouvelleLargeur, $NouvelleHauteur, $width,$height);

						$size = min(imagesx($thumb_create), imagesy($thumb_create));
						$im2 = imagecrop($thumb_create, ['x' => 0, 'y' => 0, 'width' => $size, 'height' => $size]);

						switch($file_ext)
						{
							case 'jpg' || 'jpeg':
								imagejpeg($thumb_create,$upload_image);
								imagejpeg($im2,$thumbnail,100);
								break;
							case 'png':
								imagepng($thumb_create,$upload_image);
								imagepng($im2,$thumbnail,100);
								break;
							case 'gif':
								imagegif($thumb_create,$upload_image);
								imagegif($im2,$thumbnail,100);
								break;
							default:
								imagejpeg($thumb_create,$upload_image);
								imagejpeg($im2,$thumbnail,100);
								break;
						}
						imagedestroy($im2);
					}
					else
					{
						throw new Exception('File not download ');
					}
				}
			}
			else
			{
				$param['imageHeader']=$_POST['imageHeader'];
			}

			$paramSave = json_encode($param);

			if($_POST["Date_Canevas"]==null)
			{
				$_POST["Date_Canevas"]=date("d/m/Y");
			}

			if( strstr($_POST["Canevas_Name"],'/')!=false || strstr($_POST["Canevas_Name"],'\\')!=false )
			{
				throw new Exception('Don\'t use \ or / in canevas name');
			}
			else
			{
				$NomCanevas=remove_accents(str_replace(' ','_',$_POST["Canevas_Name"]));
				if($action=='add')
				{
					if(checkNameCanevas($NomCanevas,$dbconnection)==false) // Verifier dans l'ajout d'un canevas que le nouveau nom est unique
					{
						throw new Exception('Canevas name already used');
					}
					if($inter==null)
					{
						$inter="1 year";
					}
					$id=Model_Report::addReportCanevas($dbconnection,$NomCanevas,$_POST["Description"],$inter,$_POST["Date_Canevas"],$paramSave);
					$_GET['id']=$id;

					Model_Report::addReportSendUsers($dbconnection,$_GET['id'],$user->getId(),true,true);

					if(mkdir($path_folder.$NomCanevas,0755)==false)
					{
						throw new Exception('Folder canevas not create');
					}

					$smarty->assign('l_success',$lang['REPORT_ADD_CANEVAS_SUCCES']);
					$action = 'update';
					$smarty->assign('action',$action);

					header("Location: dialog_block.php?action=update&id={$id}");
					exit(0);
				}
				else
				{
					$oldreport=Model_Report::getReportCanevas($dbconnection,$_GET["id"]);
					$oldreport=$oldreport[0];
					if($oldreport['canevas_name']!=$NomCanevas)
					{
						if(checkNameCanevas($NomCanevas,$dbconnection)==false) // Verifier dans la modification d'un canevas que le nouveau nom est unique
						{
							throw new Exception('Canevas name already used');
						}
						elseif(rename($path_folder.$oldreport['canevas_name'],$path_folder.$NomCanevas)==false) // Verifie que le folder s'est bien renommé avec le nom
						{
							throw new Exception('Folder canevas not rename');
						}
						else
						{
							// CORRIGER PATH CANEVAS
							$reports=Model_Report::getReport_of_ReportCanevas($dbconnection,$_GET["id"]);
							foreach ($reports as $r)
							{
								$r['path_html']=preg_replace('/canevas\/(\S+)\//', 'canevas/'.$NomCanevas.'/', $r['path_html']);
								$r['path_pdf']=preg_replace('/canevas\/(\S+)\//', 'canevas/'.$NomCanevas.'/', $r['path_pdf']);
								Model_Report::UpdtReport($dbconnection,$r['id'],$r['name'],date_format(new DateTime($r['date_generate']),'d/m/Y'),$r['path_html'],$r['path_pdf'],$r['canevas_id'],date_format(new DateTime($r['report_date_start']),'d/m/Y'),date_format(new DateTime($r['report_date_end']),'d/m/Y'));
							}
						}
					}
					if($inter==null)
					{
						$inter=$oldreport['canevas_interval'];
					}
					$query=Model_Report::UpdtReportCanevas($dbconnection,$_GET["id"],$NomCanevas,$_POST["Description"],$inter,$_POST["Date_Canevas"],$paramSave);
					$smarty->assign('l_success',$lang['REPORT_EDIT_CANEVAS_SUCCES']);
				}
			}

			$ListUser=$param['ListUser'];
			$ListUserCanevasReadWrite = Model_Report::getUserReadWriteCanveas($dbconnection,$_GET["id"],true);
			if(isset($ListUserCanevasReadWrite ))
			{
				$ListUser = array_diff($ListUser,$ListUserCanevasReadWrite );
			}
			$userOwnerCanevas = Model_Report::getOwnerCanevas($dbconnection,$_GET["id"]);
			$ListUserCanevasRead = Model_Report::getUserReadWriteCanveas($dbconnection,$_GET["id"]);
			$result = array_merge($ListUserCanevasRead , $ListUser);
			$result = array_unique($result);
			Model_Report::updateAccesReport($dbconnection,$result,$_GET["id"],$userOwnerCanevas[0]);
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}

	$rightOnCanevas = Model_Report::getReportSendUsers($dbconnection,$_GET["id"],$user->getId());
	$rightOnCanevas=$rightOnCanevas[0];
	if($rightOnCanevas['canevas_user_writing']==true)
	{
		$smarty->assign('report_writing_right',1);
	}

	if($action !='add') // Si on modifie un canevas
	{
		$query=Model_Report::getReportCanevas($dbconnection,$_GET["id"]);
		$query= $query[0];

		$time = explode(" ", $query['canevas_date_nextgeneration']);

		switch ($query['canevas_interval'])
		{
			case "1 year":
				$inter=$lang['REPORT_CANEVAS_INTERVAL_YEAR'];
				break;

			case "1 mon":
				$inter=$lang['REPORT_CANEVAS_INTERVAL_MONTH'];
				break;

			case "7 days":
				$inter=$lang['REPORT_CANEVAS_INTERVAL_WEEK'];
				break;

			case "1 day":
				$inter=$lang['REPORT_CANEVAS_INTERVAL_DAY'];
				break;
		}

		$ListImage = ListNomImage($path_data."miniature/");
		$param = json_decode($query['canevas_parameter'],true);

		$smarty->assign('id',$_GET["id"]);
		$smarty->assign('name',str_replace('_',' ',$query['canevas_name']));
		$smarty->assign('descr',$query['canevas_description']);
		$smarty->assign('inter',$inter);
		$smarty->assign('date',date_format(new DateTime($time[0]),'d/m/Y'));
		$smarty->assign('time',$time[1]);
		$smarty->assign('param',$param);
		$smarty->assign('NameRapport',str_replace('_',' ',$param['title']['text']));
		$taille = explode("px", $param['title']['style']['font-size']);
		$smarty->assign('namesize',$taille[0]);
		$smarty->assign('blockcolor',$param['title']['style']['color']);
		if($param['lang']!=null)
			$smarty->assign('language',$param['lang']);
		else
			$smarty->assign('language',$user->getLang());
		$smarty->assign('NameClient',$param['NameClient']);
		$smarty->assign('DescrTitle',$param['DescriptionHeader']);
		$smarty->assign('GenerateBy',$param['NomPersonneGenerateReport']);
		$smarty->assign('SubjetMail',$param['SubjetMail']);
		$smarty->assign('TextMail',$param['TextMail']);
		$smarty->assign('imageHeader',$param['imageHeader']);
		$smarty->assign('ListImage',$ListImage);

		if($deleteimage==true)
		{
			if($param['imageHeader']==$img)
			{
				try
				{
					$param['imageHeader']="min_report-logo.png";
					$smarty->assign('imageHeader',$param['imageHeader']);
					$paramSave = json_encode($param);
					$query=Model_Report::UpdtReportCanevas($dbconnection,$_GET["id"],$query['canevas_name'],$query['canevas_description'],$query['canevas_interval'],date_format(new DateTime($time[0]),'d/m/Y'),$paramSave);
				}
				catch (EsiaDbException $e)
				{
					$smarty->assign('l_error',$e->getMessage());
				}
				catch(Exception $e)
				{
					$smarty->assign('l_error',$e->getMessage());
				}
			}
		}
	}
	else // Si on ajoute un canevas, on verifie la liste d'image. Si c'est le tout premier canevas, on force la liste avec le logo Esia
	{
		$ListImage = ListNomImage($path_data."miniature/");
		if(empty($ListImage))
		{
			$ListImage= array();
			$ListImage[]="min_report-logo.png";
		}
		$param['imageHeader']="min_report-logo.png";
		$smarty->assign('param',$param);
		$smarty->assign('ListImage',$ListImage);
	}

	$users = Model_adm::searchUser($dbconnection);
	$list=array();
	foreach($users as $user)
	{
		$selected='no';
		if(in_array($user['id'],$param['ListUser']))
		{
			$selected='yes';
		}
		$list[]=array('id'=>$user['id'],
				'name'=>$user['name'],
				'mail'=>$user['mail'],
				'group'=>$user['group'],
				'selected'=>$selected
		);
	}
	$smarty->assign('ListUser',$list); // Liste des users pour avoir les info pour le mail
	$smarty->assign('LogoEsia',"min_report-logo.png");
}
elseif($action=="delete") // Si on supprime un canevas
{
	if(isset($_POST['canid']) && is_numeric($_POST['canid']))
	{
		$idCanevas = $_POST['canid'];
		//Verifier si il y a des rapports lier à se canevas
		$reports = Model_Report::getReport_of_ReportCanevas($dbconnection,$idCanevas);
		if(!empty($reports))
		{
			foreach ($reports as $report)
			{
				$pathHTML = $report['path_html'];
				$pathPDF = $report['path_pdf'];

				try
				{
					$query=Model_Report::delReport($dbconnection,$report["id"]);
					$returHtml=unlink($pathHTML);
					if($returHtml==true)
					{
						$returPdf=unlink($path.$pathPDF);
						if($returPdf!=true)
						{
							throw new Exception('File pdf not writable  '.$report['name'].'   '.$report['date_generate'].'');
						}
					}
					else
					{
						throw new Exception('File html not writable  '.$report['name'].'   '.$report['date_generate'].'');
					}
				}
				catch (EsiaDbException $e)
				{
					$smarty->assign('l_error',$e->getMessage());
				}
				catch (Exception $e)
				{
					$smarty->assign('l_error',$e->getMessage());
				}
			}
		}

		$query=Model_Report::getAllBlockOfCanevas($dbconnection,$idCanevas);
		$data=$query[0];
		try
		{  // On supprime les includeBlock reliés au canevas
			foreach($query as $val=>$v)
			{
				Model_Report::delReportIncludeBlock($dbconnection,$v['include_id']);
			}

			if($data['canevas_name']==false)
			{
				$query=Model_Report::getReportCanevas($dbconnection,$idCanevas);
				$data=$query[0];
			}
			if(rmdir($path_folder.$data['canevas_name'])==false)
			{
				throw new Exception('Folder canevas not delete');
			}

			Model_Report::delReportSendUsers_Canevas($dbconnection,$idCanevas);	// Suppression de lien entre canevas et users
			$query=Model_Report::delReportCanevas($dbconnection,$idCanevas);
			$smarty->assign('l_success',$lang['REPORT_DELETE_CANEVAS_SUCCES']);
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
  else
	{
		$query=Model_Report::getReportCanevas($dbconnection,$_GET["id"]);
		$query= $query[0];
		$param = json_decode($query['canevas_parameter'],true);

		$time = explode(" ", $query['canevas_date_nextgeneration']);
		$smarty->assign('id',$_GET["id"]);
		$smarty->assign('name',$query['canevas_name']);
		$smarty->assign('descr',$query['canevas_description']);
		$smarty->assign('inter',$query['canevas_interval']);
		$smarty->assign('NameRapport',$param['title']['text']);
		$taille = explode("px", $param['title']['style']['font-size']);
		$smarty->assign('namesize',$taille[0]);
		$smarty->assign('blockcolor',$param['title']['style']['color']);
		$smarty->assign('NameClient',$param['NameClient']);
		if($param['lang']!=null)
			$smarty->assign('language',$param['lang']);
		else
			$smarty->assign('language',$user->getLang());
		$smarty->assign('DescrTitle',$param['DescriptionHeader']);
		$smarty->assign('GenerateBy',$param['NomPersonneGenerateReport']);
		$smarty->assign('date',date_format(new DateTime($time[0]),'d/m/Y'));
		$smarty->assign('time',$time[1]);
	}
}

elseif($action=="share")
{
	$idCanevas=$_GET['id'];
	$smarty->assign('id',$idCanevas);

	if($user->getAccess($dbconnection, 'report_canevas')==1)
	{
		if($_POST["idCan"])
		{
			$userRightWrite = $_POST["usersvieuwupd"];
			$userRightView = $_POST["usersvieuw"];

			if(isset($userRightWrite))
			{
				$userRightView = array_diff($userRightView,$userRightWrite);
			}

			try
			{
				Model_Report::updateAccesCanevasWriting($dbconnection,$_GET["id"],$userRightWrite);
				Model_Report::updateAccesCanevasView($dbconnection,$_GET["id"],$userRightView);
				$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			}
			catch (EsiaDbException $e)
			{
				$smarty->assign('l_error',$e->getMessage());
			}
			catch(Exception $e)
			{
				$smarty->assign('l_error',$e->getMessage());
			}
		}
		else
		{
			$ListUserCanevasReadWrite = Model_Report::getUserReadWriteCanveas($dbconnection,$idCanevas,true);
			$ListUserCanevasRead = Model_Report::getUserReadWriteCanveas($dbconnection,$idCanevas);
			$userOwnerCanevas = Model_Report::getOwnerCanevas($dbconnection,$idCanevas);
			$users = Model_adm::searchUser($dbconnection);

			$list_user_read=array();
			$list_user_read_write=array();

			unset($users[$userOwnerCanevas[0]]);

			foreach($users as $user)
			{
				$selected='no';
				if(in_array($user['id'],$ListUserCanevasRead))
				{
					$selected='yes';
				}
				$list_user_read[]=array('id'=>$user['id'],
						'name'=>$user['name'],
						'group'=>$user['group'],
						'selected'=>$selected);
				$selected='no';
				if(in_array($user['id'],$ListUserCanevasReadWrite))
				{
					$selected='yes';
				}
				$list_user_read_write[]=array('id'=>$user['id'],
						'name'=>$user['name'],
						'group'=>$user['group'],
						'selected'=>$selected);
			}
			$smarty->assign('list_user_read_write',$list_user_read_write);
			$smarty->assign('list_user_read',$list_user_read);
		}
	}
}
elseif ($action =="duplicate")
{
	$idCanevas=$_GET['id'];
	try
	{
		if($user->getAccess($dbconnection, 'report_canevas')==1)
		{
			if($_POST["idCan"])
			{
				$old_canevas=Model_Report::getReportCanevas($dbconnection,$_POST["idCan"]);
				$old_canevas=$old_canevas[0];

				$NomCanevas=remove_accents(str_replace(' ','_',$_POST["new_name_canevas"]));
				if(checkNameCanevas($NomCanevas,$dbconnection)==false) // Verifier dans l'ajout d'un canevas que le nouveau nom est unique
				{
					throw new Exception('Canevas name already used');
				}

				$date=date_format(new DateTime($old_canevas['canevas_date_nextgeneration']),'d/m/Y');

				$id=Model_Report::addReportCanevas($dbconnection,$NomCanevas,$old_canevas['canevas_description'],$old_canevas['canevas_interval'],$date,$old_canevas['canevas_parameter']);
				Model_Report::addReportSendUsers($dbconnection,$id,$user->getId(),true,true);

				if(mkdir($path_folder.$NomCanevas,0755)==false)
				{
					throw new Exception('Folder canevas not create');
				}

				$query=Model_Report::getAllBlockOfCanevas($dbconnection,$_POST["idCan"]);
				foreach($query as $block)
				{
					Model_Report::addReportIncludeBlock($dbconnection,$block['block_id'],$id,$block['include_position'],$block['include_parameter']);
				}
				$smarty->assign('old_name',$NomCanevas);
				$smarty->assign('l_success',$lang['REPORT_ADD_CANEVAS_SUCCES']);

				$idCanevas = $id;
			}
			else
			{
				$query=Model_Report::getReportCanevas($dbconnection,$idCanevas);
				$query=$query[0];
				$smarty->assign('old_name',$query['canevas_name'].$lang['REPORT_COPY_CANEVAS']);
			}
			$smarty->assign('id',$idCanevas);
		}
	}
	catch (EsiaDbException $e)
	{
		$smarty->assign('l_error',$e->getMessage());
	}
	catch (Exception $e)
	{
		$smarty->assign('l_error',$e->getMessage());
	}
}


$smarty->display($template_path.'dialog_canevas.html');

/**
 @brief retourne la liste des images
 @detail retourne la liste des images d'un folder donné. (Dans ce cas ci,
 @params string $pathFolder le path du dossier à traiter
 @retval	null|la liste des images triée alphabétiquement
 */

function ListNomImage($pathFolder)
{
	$ext_list = Array("jpg","JPG","jpeg","JPEG","bmp", "BMP", "gif","GIF", "png","PNG"); // Extensions de photo
	$listephotos = Array();
	$dossier = opendir($pathFolder);
	for($i=0; $f = readdir($dossier); $i++)
	{
		if(is_file($pathFolder.$f))
		{
			if($f!="logoFooter.jpg")
			{
				if(in_array(preg_replace("#(.+)\.(.+)#", "$2", $f), $ext_list))
				{
					$listephotos[$i] = $f;
				}
			}
		}
	}
	closedir($dossier);
	sort($listephotos);
	return $listephotos;
}

/**
 @brief retourne le string sans les accents
 @detail enleve les accents qui se trouve dans le string
 @params string $str le string à modifier
 @params string $charset (optionnel)
 @retval	le string
 */

function remove_accents($str, $charset='utf-8')
{
	$str = htmlentities($str, ENT_NOQUOTES, $charset);

	$str = preg_replace('#&([A-za-z])(?:acute|cedil|caron|circ|grave|orn|ring|slash|th|tilde|uml);#', '\1', $str);
	$str = preg_replace('#&([A-za-z]{2})(?:lig);#', '\1', $str); // pour les ligatures e.g. '&oelig;'
	$str = preg_replace('#&[^;]+;#', '', $str); // supprime les autres caractères
	$str = str_replace("'", '_', $str); // supprime les autres caractères

	return $str;
}

/**
 @brief Indique si un nom de canevas existe déjà
 @detail retourne true si le nom de canevas passé existe pas
 @params string $nomCanveas le nom de nouveau canevas
 @params $dbconnection permet d'acceder à la base de donnée
 @retval	false si le nom existe deja|true si le nom existe pas
 */

function checkNameCanevas($nomCanveas,$dbconnection)
{
	$allCanevas = Model_Report::getReportCanevas($dbconnection);
	foreach ($allCanevas as $canevas)
	{
		if($canevas['canevas_name']==$nomCanveas)
			return false;
	}
	return true;
}
