<?php
/**
 * @name report_canevas
 * @description controle canevas
 *		Toutes les actions reliées au canevas sont traitées dans report_canevas
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
include_once $path.'/Model_esia.php';
include_once $path.'/Model_adm.php';
include_once 'Model_Report.php';

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_REPORT');
$plugin_url = $arr[0]['apache_path'];

$page_url = "$plugin_url/".$arr[0]['index_page'];
$template_path = $path.$plugin_url.'templates/';
$path_data = $path.'/data/report/pictures/';
$path_folder = $path.'/data/report/canevas/';
$navbar->addElement($lang['REPORT'], '/report_control.php');
$deleteimage=false;

if($user->getDroits($dbconnection,"report_canevas"))
{
	$smarty->assign('report_canevas', 1);
}

// Droit sur le canevas

if(isset($_GET['action']))
{
	$action = $_GET['action'];
}
else
{
	$action='view';
}
$smarty->assign('action',$action);

if($action=="view")
{
	//liste les canevas attribue au User
	$query=Model_Report::getReportCanevasUser($dbconnection,$user->getId());
	$arrayCanevas = array();
	$i=0;
	foreach($query as $row => $innerArray)
	{
		$arrayCanevas[$i]['id']=$innerArray['canevas_id'];
		$arrayCanevas[$i]['name']=str_replace('_',' ',$innerArray['canevas_name']);
		$arrayCanevas[$i]['descr']=$innerArray['canevas_description'];
		$arrayCanevas[$i]['date']=date_format(new DateTime($innerArray['canevas_date_nextgeneration']),'d/m/Y');
		$arrayCanevas[$i]['proprietary']=$innerArray['canevas_user_share'];
		$arrayCanevas[$i]['writing']=$innerArray['canevas_user_writing'];
		$i++;
	}
	$smarty->assign('action','canevas');
	$smarty->assign('arrayCanevas',$arrayCanevas);
	$smarty->assign('plugin_url',$plugin_url);

	$navbar->addElement($lang['REPORT'], '/report_control.php');
	$smarty->display($template_path.'report.html');
}
$smarty->display($template_path.'report_canevas.html');

/**
 @brief Indique si un nom de canevas existe déjà
 @detail retourne true si le nom de canevas passé existe pas
 @params string $nomCanveas le nom de nouveau canevas
 @params $dbconnection permet d'acceder à la base de donnée
 @retval	false si le nom existe deja|true si le nom existe pas
 */

function checkNameCanevas($nomCanveas,$dbconnection)
{
	$allCanevas = Model_Report::getReportCanevas($dbconnection);
	foreach ($allCanevas as $canevas)
	{
		if($canevas['canevas_name']==$nomCanveas)
			return false;
	}
	return true;
}

/**
 @brief retourne le string sans les accents
 @detail enleve les accents qui se trouve dans le string
 @params string $str le string à modifier
 @params string $charset (optionnel)
 @retval	le string
 */

function remove_accents($str, $charset='utf-8')
{
	$str = htmlentities($str, ENT_NOQUOTES, $charset);

	$str = preg_replace('#&([A-za-z])(?:acute|cedil|caron|circ|grave|orn|ring|slash|th|tilde|uml);#', '\1', $str);
	$str = preg_replace('#&([A-za-z]{2})(?:lig);#', '\1', $str); // pour les ligatures e.g. '&oelig;'
	$str = preg_replace('#&[^;]+;#', '', $str); // supprime les autres caractères
	$str = str_replace("'", '_', $str); // supprime les autres caractères

	return $str;
}
?>
