<?php
/**
 * @name report_control
 * @description controle report et config mail
 *		Toutes les actions reliées au report (sauf la generation) et à la configuration des paramètres du mail sont traitées dans report_canevas
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */

//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
include_once $path.'/Model_adm.php';
include_once 'Model_Report.php';

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_REPORT');
$plugin_url = $arr[0]['apache_path'];

$page_url = "$plugin_url/".$arr[0]['index_page'];
$template_path= $path.$plugin_url.'templates/';

$users = Model_adm::searchUser($dbconnection,$user->getId());
$smarty->assign('users',$users[$user->getId()]);

if($user->getDroits($dbconnection,"report_administration_mail"))
{
	$smarty->assign('report_administration_mail', 1);
}
if($user->getDroits($dbconnection,"report_canevas"))
{
	$smarty->assign('report_canevas', 1);
}

if(!isset($_GET['action']))
{
	if(!$user->isFinishingTutoriel(7)) 
	{
		$smarty->assign('seeTutos',7);
	}

	$smarty->assign('action','main');
	$smarty->assign('plugin_url',$plugin_url);
	
	$navbar->addElement($lang['REPORT'], './report_control.php');
	$smarty->display($template_path.'report.html');
}
elseif($_GET['action']=='historic') // Affichage des rapports
{
	$query=Model_Report::getReportUser($dbconnection,$user->getId());
	$arrayReport = array();
	$i=0;	
	foreach($query as $row => $innerArray)
	{
		$arrayReport[$i]['id']=$innerArray['id'];
		$arrayReport[$i]['idCanevas']=$innerArray['canevas_id'];
		$arrayReport[$i]['canevas_user_writing']=$innerArray['canevas_user_writing'];
		$arrayReport[$i]['canevas_name']=str_replace('_',' ',$innerArray['canevas_name']);
		$arrayReport[$i]['name']=str_replace('_',' ',$innerArray['name']);
		$arrayReport[$i]['path_html']=$innerArray['path_html'];
		$arrayReport[$i]['path_pdf']=$innerArray['path_pdf'];
		$arrayReport[$i]['date']=date_format(new DateTime($innerArray['date_generate']),'d/m/Y');
		$arrayReport[$i]['date_start']=date_format(new DateTime($innerArray['report_date_start']),'d/m/Y');
		$arrayReport[$i]['date_end']=date_format(new DateTime($innerArray['report_date_end']),'d/m/Y');
		$i++;
	}
	$smarty->assign('action','historic');
	$smarty->assign('arrayReport',$arrayReport);
	$smarty->assign('plugin_url',$plugin_url);

	
	$navbar->addElement($lang['REPORT'], './report_control.php');
	$smarty->display($template_path.'report.html');
}
elseif($_GET['action']=='config_mail') // Affichage des paramètres du mail, ainsi que la modif
{
	try
	{	
		if($_POST['serveur_smtp']!=null)
		{
			$serveur = $_POST['serveur_smtp'];
			$user_mail = $_POST['user_mail'];
			$port_mail = $_POST['port_mail'];
			$ssl_mail= $_POST['ssl_mail'];
			$from= $_POST['from'];
			
			$pwd_mail  = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_PASSWORD");
			$pwd = str_repeat('*',strlen($pwd_mail['REPORT_MAIL_PASSWORD']['value']));
			if($pwd != $_POST['pwd_mail'])
			{
				$arr = array('REPORT_MAIL_PASSWORD'=>$_POST['pwd_mail']);
				Model_adm::updateConfiguration($dbconnection,$arr);
			}
			
			$arr = array('REPORT_MAIL_SMTP'=>$serveur);
			Model_adm::updateConfiguration($dbconnection,$arr);
			$arr = array('REPORT_MAIL_FROM'=>$from);
			Model_adm::updateConfiguration($dbconnection,$arr);
			$arr = array('REPORT_MAIL_USER'=>$user_mail);
			Model_adm::updateConfiguration($dbconnection,$arr);
			$arr = array('REPORT_MAIL_SMTP_PORT'=>$port_mail);
			Model_adm::updateConfiguration($dbconnection,$arr);
			$arr = array('REPORT_MAIL_SSL'=>$ssl_mail);
			Model_adm::updateConfiguration($dbconnection,$arr);
			$smarty->assign('l_success',$lang['REPORT_UPDATE_MAIL_SUCCES']);		
			
			$smarty->assign('serveur_smtp',$serveur);
			$smarty->assign('user_mail',$user_mail);
			$smarty->assign('pwd_mail',$pwd_mail);
			$smarty->assign('port_mail',$port_mail);
			$smarty->assign('ssl_mail',$ssl_mail);
			$smarty->assign('from',$from);
			
			$smarty->assign('action','main');
		}
		else
		{
			$serveur   = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SMTP");
			$user_mail = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_USER");
			
			$pwd_mail  = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_PASSWORD");
			$port_mail = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SMTP_PORT");
			$ssl_mail = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SSL");
			$from = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_FROM");
			
			$smarty->assign('serveur_smtp',$serveur['REPORT_MAIL_SMTP']['value']);
			$smarty->assign('from',$from['REPORT_MAIL_FROM']['value']);
			$smarty->assign('user_mail',$user_mail['REPORT_MAIL_USER']['value']);
			
			$pwd = str_repeat('*',strlen($pwd_mail['REPORT_MAIL_PASSWORD']['value']));
			$smarty->assign('pwd_mail',$pwd);
			$smarty->assign('port_mail',$port_mail['REPORT_MAIL_SMTP_PORT']['value']);
			$smarty->assign('ssl_mail',$ssl_mail['REPORT_MAIL_SSL']['value']);		
						
			$smarty->assign('action','config_mail');
		}			
				
		$smarty->assign('plugin_url',$plugin_url);		
		$navbar->addElement($lang['REPORT'], './report_control.php');
		$smarty->display($template_path.'report.html');
	}
	catch (EsiaDbException $e)
	{
		echo $e->getMessage();
		$smarty->assign('l_error',$e->getMessage());
	}
	catch (Exception $e)
	{
		echo $e->getMessage();
		$smarty->assign('l_error',$e->getMessage());
	}
}
elseif($_GET['action']=="sendmailtest") // Envoie du mail de test
{
	try
	{
		$userdata = Model_adm::searchUser($dbconnection,$user->getId());

		// Info Mail
		$serveur     = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SMTP");
		$utilisateur = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_USER");
		$passwordMail= Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_PASSWORD");
		$sll_mail    = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SSL");
		$port 		 = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SMTP_PORT");
		$expiditor 	 = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_FROM");

		$sujet=$lang['REPORT_TEST_SUJET_MAIL'];
		$data=$lang['REPORT_TEST_DATA_MAIL'];
		$exec = $path.$plugin_url."send_mail.pl";
		$exec .=" -H '".cleanArgs($serveur['REPORT_MAIL_SMTP']['value'])."'";
		$exec .=" -p '".cleanArgs($port['REPORT_MAIL_SMTP_PORT']['value'])."'";
		$exec .=" -S '".cleanArgs($sll_mail['REPORT_MAIL_SSL']['value'])."'";
		
		$exec .=" -e '".cleanArgs($expiditor['REPORT_MAIL_FROM']['value'])."'";
		$exec .=" -U '".cleanArgs($utilisateur['REPORT_MAIL_USER']['value'])."'";
		$exec .=" -P '".cleanArgs($passwordMail['REPORT_MAIL_PASSWORD']['value'])."'";
		$exec .=" -T '".cleanArgs($userdata[$user->getId()]['mail'])."'";
		//echo $exec." -s '".$sujet."' -d '".$data."'<br />";
		shell_exec($exec." -s '".$sujet."' -d '".$data."'");
		$smarty->assign('l_success',$lang['REPORT_SEND_MAIL_SUCCES']);
		
		$smarty->assign('action','send_mail_ok');	
		$smarty->assign('plugin_url',$plugin_url);
		$navbar->addElement($lang['REPORT'], './report_control.php');
		$smarty->display($template_path.'report.html');
	}
	catch(EsiaDbException $e)
	{
		$smarty->assign('l_error',$e->getMessage());
	}
	catch(Exception $e)
	{
		$smarty->assign('l_error',$e->getMessage());
	}
}
elseif($_GET['action']=='AfficheHtml') // Afficher le code html du rapport selectionner
{
	try
	{
		// AFFICHER HTML
		$query=Model_Report::getReport($dbconnection,$_GET["id"]);
		$query=$query[0];		
		$smarty->display($query['path_html']);
	}
	catch (EsiaDbException $e)
	{
		echo $e->getMessage();
		$smarty->assign('l_error',$e->getMessage());
	}
	catch (Exception $e)
	{
		echo $e->getMessage();
		$smarty->assign('l_error',$e->getMessage());
	}
}
elseif($_GET['action']=='SupprimerReport') // Suppression un rapport (Dans la Bd, le code Html et le fichier Pdf)
{
	$query=Model_Report::getReport($dbconnection,$_GET["id"]);
	$query=$query[0];
	$smarty->assign('del_report',$query);
	$smarty->assign('action','SupprimerReport');
	$pathHTML = $query['path_html'];
	$pathPDF = $query['path_pdf'];
	if(!empty($_POST['id']) && isset($_POST['id']))
	{
		try
		{
			$query=Model_Report::delReport($dbconnection,$_GET["id"]);
			$returHtml=unlink($pathHTML);
			if($returHtml==true)
			{
				$returPdf=unlink($path.$pathPDF);
				if($returPdf==true)
				{
					$smarty->assign('l_success',$lang['REPORT_DELETE_REPORT_SUCCES']);
					$smarty->assign('action','DeleteReport');
				}
				else
				{
					throw new Exception('File pdf not writable');
				}
			}
			else
			{
				throw new Exception('File html not writable');
			}
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		$smarty->assign('action','DeleteReport');
	}
	$navbar->addElement($lang['REPORT'], './report_control.php');
	$smarty->display($template_path.'report.html');
}
function cleanArgs($val)
{
	$val = trim($val);
	$val = escapeshellcmd($val);
	return $val;
}
?>
