<?php
/**
 * @name report_generate_none
 * @description fichier qui s'execute grace à la tache cron
 *		Genere un rapport et l'envoie aux personnes interessées
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
include_once $path.'/Model_adm.php';
include_once 'Model_Report.php';

$NomRapport = $_POST['NameReport'];
$datemandeb = $_POST["Date_Man_Deb"];
$datemanfin = $_POST["Date_Man_Fin"];
$generationmanuelle = $_POST['generationmanuelle'];
$sendmail = $_POST['sendmail'];
$Canevas_Id = $_GET["idCanevas"];
$language = $_GET["language"];
$Action = $_GET["action"];
$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_REPORT');
$plugin_url = $arr[0]['apache_path'];
$page_url = "$plugin_url/".$arr[0]['index_page'];
$template_path= $path.$plugin_url.'templates/';


if($Action=="generate")
{
	// Generation rapport
	try
	{
		$NomRapport=remove_accents(str_replace(' ','_',$NomRapport));
		if($generationmanuelle=='on')
		{
			list($day, $month, $year) = explode('/', $datemandeb);
			$Start = new DateTime();
			$Start->setDate($year, $month, $day);
			$Start=date_format($Start, 'Y-m-d');

			list($day, $month, $year) = explode('/', $datemanfin);
			$End = new DateTime();
			$End->setDate($year, $month, $day);
			$End=date_format($End, 'Y-m-d');
			if($End>$Start)
			{
				$idReport = shell_exec("php report_generate.php  -a ".$Action." -i ".$Canevas_Id." -n '".$NomRapport."' -d '".$Start."' -f '".$End."' -l '".$language."'");
			}
			else
			{
				throw new Exception($lang['REPORT_ERREUR_DATE_MAN']);
			}
		}
		else
		{
			$idReport = shell_exec("php report_generate.php  -a ".$Action." -i ".$Canevas_Id." -n '".$NomRapport."' -l '".$language."'");
		}

		$smarty->assign('action','update');
		$smarty->assign('id',$Canevas_Id);
		$action='update';

		$rightOnCanevas = Model_Report::getReportSendUsers($dbconnection,$Canevas_Id,$user->getId());
		$rightOnCanevas=$rightOnCanevas[0];
		if($rightOnCanevas['canevas_user_writing']==true)
		{
			$smarty->assign('report_writing_right',1);
		}

		$query=Model_Report::getReportCanevas($dbconnection,$Canevas_Id);
		$query= $query[0];

		$time = explode(" ", $query['canevas_date_nextgeneration']);

		switch ($query['canevas_interval'])
		{
			case "1 year":
				$inter=$lang['REPORT_CANEVAS_INTERVAL_YEAR'];
				break;

			case "1 mon":
				$inter=$lang['REPORT_CANEVAS_INTERVAL_MONTH'];
				break;

			case "7 days":
				$inter=$lang['REPORT_CANEVAS_INTERVAL_WEEK'];
				break;

			case "1 day":
				$inter=$lang['REPORT_CANEVAS_INTERVAL_DAY'];
				break;
		}

		$blockRelier=Model_Report::getAllBlockOfCanevas($dbconnection,$Canevas_Id);
		$block=Model_Report::getReportBlock($dbconnection);
		$ListImage = ListNomImage($path_data."miniature/");
		$param = json_decode($query['canevas_parameter'],true);
		$blockname=extract_name_block($blockRelier);

		$smarty->assign('name',str_replace('_',' ',$query['canevas_name']));
		$smarty->assign('descr',$query['canevas_description']);
		$smarty->assign('inter',$inter);
		$smarty->assign('date',date_format(new DateTime($time[0]),'d/m/Y'));
		$smarty->assign('time',$time[1]);
		$smarty->assign('param',$param);
		$smarty->assign('NameRapport',str_replace('_',' ',$param['title']['text']));
		$taille = explode("px", $param['title']['style']['font-size']);
		$smarty->assign('namesize',$taille[0]);
		$smarty->assign('blockcolor',$param['title']['style']['color']);

		if($param['lang']!=null)
			$smarty->assign('language',$param['lang']);
		else
			$smarty->assign('language',$user->getLang());
		$smarty->assign('NameClient',$param['NameClient']);
		$smarty->assign('DescrTitle',$param['DescriptionHeader']);
		$smarty->assign('GenerateBy',$param['NomPersonneGenerateReport']);
		$smarty->assign('SubjetMail',$param['SubjetMail']);
		$smarty->assign('TextMail',$param['TextMail']);
		$smarty->assign('imageHeader',$param['imageHeader']);
		$smarty->assign('ListBlock',$blockRelier);
		$smarty->assign('ListBlockName',$blockname);
		$smarty->assign('ListBlockToAdd',$block);
		$smarty->assign('ListImage',$ListImage);

		$users = Model_adm::searchUser($dbconnection);
		$list=array();
		foreach($users as $user)
		{
			$selected='no';
			if(in_array($user['id'],$param['ListUser']))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$user['id'],
					'name'=>$user['name'],
					'mail'=>$user['mail'],
					'group'=>$user['group'],
					'selected'=>$selected
			);
		}
		$smarty->assign('ListUser',$list);

		if($sendmail=='on') // Si il est demandé de l'envoyer par mail
		{
			// Info Mail
			$serveur     = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SMTP");
			$utilisateur = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_USER");
			$passwordMail= Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_PASSWORD");
			$sll_mail    = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SSL");
			$port 		 = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SMTP_PORT");
			$expiditor	 = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_FROM");

			// Recup le Rapport à enovoyer
			$ListReport = Model_Report::getReport($dbconnection,$idReport);

			// Recup AdrMail
			$Canevas=Model_Report::getReportCanevas($dbconnection,$Canevas_Id);
			$Canevas=$Canevas[0];
			$param = json_decode($Canevas['canevas_parameter'],true);

			$sujet = $param['SubjetMail'];
			$data = $param['TextMail'];

			$sujet= preg_replace('#\'#','\'\\\'\'',$sujet);
			$data = preg_replace('#\\n#','<br>',$data);
			$data = preg_replace('#\'#','\'\\\'\'',$data);

			$exec = $path.$arr[0]['apache_path']."send_mail.pl";
			$exec .=" -H '".cleanArgs($serveur['REPORT_MAIL_SMTP']['value'])."'";
			$exec .=" -p '".cleanArgs($port['REPORT_MAIL_SMTP_PORT']['value'])."'";
			$exec .=" -S '".cleanArgs($sll_mail['REPORT_MAIL_SSL']['value'])."'";
			
			$exec .=" -e '".cleanArgs($expiditor['REPORT_MAIL_FROM']['value'])."'";
			$exec .=" -U '".cleanArgs($utilisateur['REPORT_MAIL_USER']['value'])."'";
			$exec .=" -P '".cleanArgs($passwordMail['REPORT_MAIL_PASSWORD']['value'])."'";
			
			foreach ($param['ListUser'] as $idUser)
			{
				$User = Model_adm::searchUser($dbconnection,$idUser);
				foreach ($User as $u)
				{
					$admail = $u['mail'];
					// Envoie Mail
					foreach ($ListReport as $report)
					{
						$path_pdf=$report['path_pdf'];
						preg_match("/.*\/(.*)/",$path_pdf,$filepdf);
						exec($exec." -T ".$admail." -s '".$sujet."' -d '".$data."' -f ".$filepdf[1]." -F ".$path.$report['path_pdf']);
					}
				}
			}
		}
		ob_start();
		ob_end_flush();
		header('Location: '.$plugin_url.'/dialog_block.php?action=update&id='.$Canevas_Id.'&sendsucces=true');
		exit(0);
		

	}
	catch (EsiaDbException $e)
	{
		$smarty->assign('l_error',$e->getMessage());
	}
	catch (Exception $e)
	{
		$smarty->assign('l_error',$e->getMessage());
	}
}
elseif($Action=="viewer")
{
	try
	{
		if($generationmanuelle=='on')
		{
			list($day, $month, $year) = explode('/', $datemandeb);
			$Start = new DateTime();
			$Start->setDate($year, $month, $day);
			$Start=date_format($Start, 'Y-m-d');

			list($day, $month, $year) = explode('/', $datemanfin);
			$End = new DateTime();
			$End->setDate($year, $month, $day);
			$End=date_format($End, 'Y-m-d');
			if($End>$Start)
			{
				$report = shell_exec("php report_generate.php  -a generate -i ".$Canevas_Id." -n '".$NomRapport."' -v true  -d '".$Start."' -f '".$End."'  -l '".$language."'");
			}
			else
			{
				throw new Exception($lang['REPORT_ERREUR_DATE_MAN']);
			}
		}
		else
		{
			$report = shell_exec("php report_generate.php  -a generate -i ".$Canevas_Id." -n '".$NomRapport."' -v true  -l '".$language."'");
		}
		$smarty->assign('report',$report);
		$smarty->assign('id',$Canevas_Id);
		$smarty->assign('action','viewer_report');
	}
	catch (EsiaDbException $e)
	{
		$smarty->assign('l_error',$e->getMessage());
	}
	catch (Exception $e)
	{
		$smarty->assign('l_error',$e->getMessage());
	}
}
$smarty->assign('template_path',$template_path);
$smarty->display($template_path.'dialog_block.html');

/**
 @brief retourne le string sans les accents
 @detail enleve les accents qui se trouve dans le string
 @params string $str le string à modifier
 @params string $charset (optionnel)
 @retval	le string
 */

function remove_accents($str, $charset='utf-8')
{
	$str = htmlentities($str, ENT_NOQUOTES, $charset);

	$str = preg_replace('#&([A-za-z])(?:acute|cedil|caron|circ|grave|orn|ring|slash|th|tilde|uml);#', '\1', $str);
	$str = preg_replace('#&([A-za-z]{2})(?:lig);#', '\1', $str); // pour les ligatures e.g. '&oelig;'
	$str = preg_replace('#&[^;]+;#', '', $str); // supprime les autres caractères
	$str = str_replace("'", '_', $str); // supprime les autres caractères

	return $str;
}

/**
 @brief retourne la liste des images
 @detail retourne la liste des images d'un folder donné. (Dans ce cas ci,
 @params string $pathFolder le path du dossier à traiter
 @retval	null|la liste des images triée alphabétiquement
 */

function ListNomImage($pathFolder)
{
	$ext_list = Array("jpg","JPG","jpeg","JPEG","bmp", "BMP", "gif","GIF", "png","PNG"); // Extensions de photo
	$listephotos = Array();
	$dossier = opendir($pathFolder);
	for($i=0; $f = readdir($dossier); $i++)
	{
		if(is_file($pathFolder.$f))
		{
			if($f!="logoFooter.jpg")
			{
				if(in_array(preg_replace("#(.+)\.(.+)#", "$2", $f), $ext_list))
				{
					$listephotos[$i] = $f;
				}
			}
		}
	}
	closedir($dossier);
	sort($listephotos);
	return $listephotos;
}

/**
 * @brief retourne les noms (array) personnalisés des blocs
 * @detail retourne les noms personnalisés des blocs
 * @params array $block contient le json parameter des blocs
 * @retval array contenant les noms
 */
function extract_name_block($block)
{
	$blockname = array();
	$name = array();
	$cmpt=0;
	foreach ($block as $val)
	{
		array_push($blockname,json_decode($val['include_parameter'],true));
		array_push($name,$blockname[$cmpt]['title']['text']);
		$cmpt++;
	}
	return $name;
}
function cleanArgs($val)
{
	$val = trim($val);
	$val = escapeshellcmd($val);
	return $val;
}
?>
