#!/usr/bin/php
<?php
/**
 * @name Correction_send_user.php
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date 05/09/2017
 */

$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
include_once '/usr/local/esia/public_html/esia.conf.php';
include_once '/usr/local/esia/public_html/Model_esia.php';

$ERRORS=array('OK'=>0,'WARNING'=>1,'CRITICAL'=>2,'UNKNOWN'=>3);

//connection à la base de donne
try
{
    $dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
    $dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
    echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
    echo 'N   : '.$e->getCode();
    exit($ERRORS['UNKNOWN']);
}

function executeRequest($query,$params=array()){
	try{
		$query = Model_esia::executeStatement($query,$params);
	}
	catch(Exception $ex){
		echo $ex->getMessage() . "\n";
	}
	return $query;
}
      
try
{    
/*  $query= $dbconnection->prepare("ALTER TABLE report_send_users add column canevas_user_share BOOLEAN default FALSE;");
    $query = Model_esia::executeStatement($query,array());
    $query= $dbconnection->prepare("ALTER TABLE report_send_users add column canevas_user_writing BOOLEAN default FALSE;");
    $query = Model_esia::executeStatement($query,array());*/
    $query= $dbconnection->prepare("UPDATE report_send_users SET canevas_user_share = true, canevas_user_writing=true;");
    $query = executeRequest($query,array());
    $query= $dbconnection->prepare("SELECT canevas_id, canevas_parameter->'ListUser' as users
                                    FROM report_canevas
                                    JOIN report_send_users ON send_canevas_id = report_canevas.canevas_id
                                    GROUP BY canevas_id;");            
    $query = executeRequest($query,array());
    $Reponse=array();
    while($row=$query->fetch(PDO::FETCH_OBJ))
    {
        $Reponse[]=array('canevas_id'=>$row->canevas_id,
                          'users'=>$row->users,                                       
                        );
    }
    $ListUser=array();
    foreach ($Reponse as $val)
    {            
        preg_match_all("/(\d+)/",$val["users"],$matches);
        $ListUser[]=array('canevas'=>$val["canevas_id"],
                          'users'=>$matches[1],);
    }

   $query= $dbconnection->prepare("SELECT send_user_id,send_canevas_id
                                   FROM report_send_users
                                   WHERE canevas_user_share = true;");            
    $query = executeRequest($query,array());
    $ownerCanevas=array();
    while($row=$query->fetch(PDO::FETCH_OBJ))
    {
        $ownerCanevas[]=array('canevas'=>$row->send_canevas_id,
                          'send_user_id'=>$row->send_user_id,                                       
                        );
    }

    $ListInsert=array();
    foreach($ListUser as $val)
    {
        foreach ($val['users'] as $k => $v) 
        {            
            if(in_multiarray($v, $ownerCanevas,"send_user_id")==1)
            {
                array_splice($val['users'], $k, 1);               
            }
        }
        $ListInsert[]=array('canevas'=>$val["canevas"],
                          'users'=>$val['users'],); 
    }

    foreach ($ListInsert as $value) 
    {
        $query = $dbconnection->prepare("INSERT INTO report_send_users(send_user_id, send_canevas_id) VALUES (?,?);");
        foreach ($val['users'] as $k => $v) 
        {            
            $query = executeRequest($query,array($v,$value['canevas']));
        }
    }

}
catch (EsiaDbException $e)
{
    echo 'EsiaDbException SQL ERROR: '.$e->getMessage().'<br />';
    echo 'N   : '.$e->getCode();
    exit($ERRORS['UNKNOWN']);
}
catch (Exception $e)
{
    echo 'Exception SQL ERROR: '.$e->getMessage().'<br />';
    echo 'N   : '.$e->getCode();
    exit($ERRORS['UNKNOWN']);
}


function in_multiarray($elem, $array,$field)
{
    $top = sizeof($array) - 1;
    $bottom = 0;
    while($bottom <= $top)
    {
        if($array[$bottom][$field] == $elem)
            return true;
        else 
            if(is_array($array[$bottom][$field]))
                if(in_multiarray($elem, ($array[$bottom][$field])))
                    return true;

        $bottom++;
    }        
    return false;
}
